

#define JAL_OPCODE	0x0C000000
#define J_OPCODE	0x08000000
#define SC_OPCODE	0x0000000C
#define JR_RA		0x03e00008

#define NOP	0x00000000

#define MAKE_JUMP(a, f) _sw(J_OPCODE | (((u32)(f) & 0x0ffffffc) >> 2), a); 
#define MAKE_CALL(a, f) _sw(JAL_OPCODE | (((u32)(f) >> 2)  & 0x03ffffff), a); 
#define MAKE_SYSCALL(a, n) _sw(SC_OPCODE | (n << 6), a);
#define JUMP_TARGET(x) (0x80000000 | ((x & 0x03FFFFFF) << 2))

#define REDIRECT_FUNCTION(a, f) _sw(J_OPCODE | (((u32)(f) >> 2)  & 0x03ffffff), a);  _sw(NOP, a+4);
#define MAKE_DUMMY_FUNCTION0(a) _sw(0x03e00008, a); _sw(0x00001021, a+4);
#define MAKE_DUMMY_FUNCTION1(a) _sw(0x03e00008, a); _sw(0x24020001, a+4);

void ClearCaches();

typedef struct
{
	void *next;
	u64 mtime;
	u8 folder;
	char name;
} Category;

void ClearCategories();
Category *GetNextCategory(Category *prev);
void AddCategory(char *category, u64 mtime);
void DelCategory(char *category);
int CountCategories();

int scePaf_strlen(const char *path);
int scePaf_memset(void *buff ,int c ,int size);
int scePaf_memcmp(const void *path , const void *name , int c);
int scePaf_sprintf(char *buffer , const char *format , ...);
int scePaf_snprintf(char *buffer,int c , const char *format, ...);
int scePaf_memcpy(void *path , void *name , int size);
int scePaf_strcpy(char *path , const char *name);
int scePaf_strcmp(const char *path , const char *name);
void *scePaf_malloc(int size );
int scePaf_free(void *buffer);

